/*!
        @file    $Id:: force_F_Staggered_eo.h #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate:: 2013-07-12 14:43:23 #$

        @version $LastChangedRevision: 929 $
*/

#ifndef FORCE_F_STAGGERED_EO_INCLUDED
#define FORCE_F_STAGGERED_EO_INCLUDED

#include "force.h"
#include "fopr_Staggered_eo.h"

//! Force calculation for even-odd staggered fermion operator.

/*!
    This is a temporary implementation.
                                [28 Dec 2011 H.Matsufuru]
    (Coding history will be recovered from trac.)
    YAML is implemented.        [14 Nov 2012 Y.Namekawa]
 */

//- parameters class
class Parameters_Force_F_Staggered_eo : virtual public Parameters
{
 public:
  Parameters_Force_F_Staggered_eo();
};
//- end

class Force_F_Staggered_eo : public Force
{
 private:
  Field_G *m_Ueo;

  double             m_mq;
  std::valarray<int> m_boundary;
  Fopr_Staggered_eo  *m_fopr_ks;
  Field_F_1spinor    m_psf;
  Index_eo           m_index_eo;
  ShiftField_eo      m_shift_eo;

 public:

  Force_F_Staggered_eo()
    : Force()
  {
    m_fopr_ks = new Fopr_Staggered_eo();
    m_boundary.resize(CommonParameters::Ndim());
  }

  ~Force_F_Staggered_eo()
  {
    delete m_fopr_ks;
  }

  void set_parameters(const Parameters& params);

//  void set_parameters (const Parameters_Fopr_Staggered_eo& params);
  void set_parameters(double mq, const std::valarray<int> bc);

  void set_config(Field *Ueo)
  {
    m_Ueo = (Field_G *)Ueo;
    m_fopr_ks->set_config(Ueo);
  }

  Field force_core(const Field& eta);
  Field force_udiv(const Field& eta);
  Field force_udiv1(const Field_F_1spinor& zeta, const Field_F_1spinor& eta,
                    int ieo);
};
#endif
