/*!
        @file    $Id:: corr2pt_Staggered.h #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate:: 2013-07-18 11:55:46 #$

        @version $LastChangedRevision: 934 $
*/


#ifndef CORR2PT_STAGGERED_INCLUDED
#define CORR2PT_STAGGERED_INCLUDED

#include <valarray>
#include "defs.h"
#include "commonParameters.h"
#include "index_lex.h"
#include "field_F_1spinor.h"
#include "bridgeIO.h"

//! Two-point correlator for staggered fermions.

/*!
   This is just a temporary implementation for test of
   staggered solver.
                              [28 Dec 2011 H.Matsufuru]
 */

class Corr2pt_Staggered
{
 protected:
  Bridge::VerboseLevel m_vl;

 private:
  Index_lex m_index;

 public:
  Corr2pt_Staggered()
    : m_vl(CommonParameters::Vlevel()) {}

  void set_parameter_verboselevel(const Bridge::VerboseLevel vl) { m_vl = vl; }

  void meson(
    std::valarray<double>&,
    const std::valarray<Field_F_1spinor>& sq1,
    const std::valarray<Field_F_1spinor>& sq2);
};
#endif
