/*!
        @file    $Id:: fprop_Domainwall_4d.h #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru)
                 $LastChangedBy: namekawa $

        @date    $LastChangedDate:: 2013-05-29 16:29:31 #$

        @version $LastChangedRevision: 889 $
*/


#ifndef FPROP_DOMAINWALL_4D_INCLUDED
#define FPROP_DOMAINWALL_4D_INCLUDED

#include "fopr_Domainwall.h"
#include "solver.h"

#include "bridgeIO.h"
using Bridge::vout;

//! 4D-space quark propagator of domain-wall fermion.

/*!
    This is temporary implementation.
                                        [28 Dec 2011 H.Matsufuru]
    (Coding history will be recovered from trac.)
    Redundant argument is deleted.
                                        [03 Mar 2013 Y.Namekawa]
 */

class Fprop_Domainwall_4d
{
 protected:
  Bridge::VerboseLevel m_vl;

 private:
  Fopr_Domainwall *m_fopr_dw;
  Solver          *m_solver;

 public:
  Fprop_Domainwall_4d(Fopr_Domainwall *fopr_dw, Solver *solver)
    : m_vl(CommonParameters::Vlevel()), m_fopr_dw(fopr_dw), m_solver(solver) {}

  ~Fprop_Domainwall_4d() {}

  void set_config(Field *);

  void invert_D(Field&, const Field&, int&, double&);
  void invert_DdagD(Field&, const Field&, int&, double&);
};
#endif
