/*!
        @file    $Id:: fprop_Staggered_eo.h #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate:: 2013-04-27 12:28:50 #$

        @version $LastChangedRevision: 875 $
*/

#ifndef FPROP_STAGGERED_EO_INCLUDED
#define FPROP_STAGGERED_EO_INCLUDED

#include "fopr_Staggered_eo.h"

#include "solver.h"

#include "bridgeIO.h"
using Bridge::vout;

//! Get staggered quark propagator for even-odd fermion operator.

/*!
    This is temporary implementation.
                                        [28 Dec 2011 H.Matsufuru]
    (Coding history will be recovered from trac.)
    Selectors are implemented.          [03 Mar 2013 Y.Namekawa]
    (Selectors are replaced with factories by Aoyama-san)
 */

class Fprop_Staggered_eo
{
 protected:
  Bridge::VerboseLevel m_vl;

 private:
  Fopr_Staggered_eo *m_fopr_eo;
  Index_eo          m_index_eo;

  Parameters m_params_solver;

 public:
  Fprop_Staggered_eo(Fopr_Staggered_eo *fopr)
    : m_vl(CommonParameters::Vlevel()), m_fopr_eo(fopr) {}

  void set_parameters(const Parameters& params_solver);

  void calc(Field_F_1spinor&, const Field_F_1spinor&);
};
#endif
