/*!
        @file    $Id:: source_Staggered_Wall.h #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate:: 2013-07-12 14:43:23 #$

        @version $LastChangedRevision: 929 $
*/

#ifndef SOURCE_STAGGERED_WALL_INCLUDED
#define SOURCE_STAGGERED_WALL_INCLUDED

#include "field_F_1spinor.h"
#include "index_lex.h"
#include "parameters.h"

#include "bridgeIO.h"
using Bridge::vout;

//! Setting source vector with wall source for staggered fermion.

/*!
    This is a temporary implementation for test of staggered
    fermion.
                                 [28 Dec 2011 H.Matsufuru]
    (Coding history will be recovered from trac.)
    YAML is implemented.         [14 Nov 2012 Y.Namekawa]
 */

//- parameters class
class Parameters_Source_Staggered_Wall : virtual public Parameters
{
 public:
  Parameters_Source_Staggered_Wall();
};
//- end

class Source_Staggered_Wall
{
 protected:
  Bridge::VerboseLevel m_vl;

 private:
  int       m_t_src;
  Index_lex m_index;

  Field src_wall_1;
  Field src_wall_2;

 public:

  Source_Staggered_Wall()
    : m_vl(CommonParameters::Vlevel()) {}

  void set_parameters(const Parameters& params);
  void set_parameters(const int source_position);

  void set_parameter_verboselevel(const Bridge::VerboseLevel vl) { m_vl = vl; }

  void set(Field_F_1spinor& src, const int ic, const int i_src);

 private:
  void init();
};
#endif
