/*!
        @file    $Id: solver_CGNR.h 929 2013-07-12 05:43:23Z aoym $

        @brief

        @author
                 $LastChangedBy: aoym $

        @date    $LastChangedDate: 2013-07-12 14:43:23 +0900 (金, 12  7月 2013) $

        @version $LastChangedRevision: 929 $
*/

#ifndef SOLVER_CGNR_INCLUDED
#define SOLVER_CGNR_INCLUDED

#include "solver_CG.h"

//- parameters class
class Parameters_Solver_CGNR : virtual public Parameters
{
 public:
  Parameters_Solver_CGNR();
};
//- end

//! CGNR solver.

/*!

  solve D x = b
  by
  (Ddag D) x = b'  and  b' = Ddag b.

  delegate to base CG solver.
 */

class Solver_CGNR : public Solver_CG
{
 public:

  Solver_CGNR(Fopr *fopr)
    : Solver_CG(fopr) {}

  ~Solver_CGNR() {}

  void set_parameters(const Parameters& params);

  void solve(Field& solution, const Field& source, int& Nconv, double& diff);

  Fopr *get_fopr() { return this->Solver_CG::get_fopr(); }

 private:
};
#endif
